testthread.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <signal.h>`
`#include "SDL.h"`
Include dependency graph for testthread.c:

Go to the source code of this file.

## Functions

static void | quit (int rc)
int | ThreadFunc (void *data)
static void | killed (int sig)
int | main (int argc, char *argv[])

## Variables

static SDL_TLSID | tls
static int | alive = 0

## Function Documentation

## killed()

static void killed | ( | int | sig | ) |

static

Definition at line 47 of file testthread.c.

References alive, quit(), SDL_Delay, and SDL_Log.

Referenced by main().

{
SDL_Log("Killed with SIGTERM, waiting 5 seconds to exit\n");
SDL_Delay(5 * 1000);
alive = 0;
quit(0);
}
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
alive
static int alive
Definition: testthread.c:22
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
quit
static void quit(int rc)
Definition: testthread.c:26

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 56 of file testthread.c.

References alive, killed(), NULL, quit(), SDL_assert, SDL_CreateThread, SDL_Delay, SDL_GetError, SDL_Init, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, SDL_Quit, SDL_TLSCreate, SDL_TLSGet, SDL_TLSSet, SDL_WaitThread, ThreadFunc(), and tls.

{
SDL_Thread *thread;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Load the SDL library */
if (SDL_Init(0) < 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL: %s\n", SDL_GetError());
return (1);
}
tls = SDL_TLSCreate();
SDL_assert(tls);
SDL_TLSSet(tls, "main thread", NULL);
SDL_Log("Main thread data initially: %s\n", (const char *)SDL_TLSGet(tls));
alive = 1;
thread = SDL_CreateThread(ThreadFunc, "One", "#1");
if (thread == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create thread: %s\n", SDL_GetError());
quit(1);
}
SDL_Delay(5 * 1000);
SDL_Log("Waiting for thread #1\n");
alive = 0;
SDL_WaitThread(thread, NULL);
SDL_Log("Main thread data finally: %s\n", (const char *)SDL_TLSGet(tls));
alive = 1;
signal(SIGTERM, killed);
thread = SDL_CreateThread(ThreadFunc, "Two", "#2");
if (thread == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create thread: %s\n", SDL_GetError());
quit(1);
}
raise(SIGTERM);
SDL_Quit(); /* Never reached */
return (0); /* Never reached */
}
SDL_TLSSet
#define SDL_TLSSet
Definition: SDL_dynapi_overrides.h:482
ThreadFunc
int ThreadFunc(void *data)
Definition: testthread.c:33
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
killed
static void killed(int sig)
Definition: testthread.c:47
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:58
SDL_TLSCreate
#define SDL_TLSCreate
Definition: SDL_dynapi_overrides.h:480
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
alive
static int alive
Definition: testthread.c:22
SDL_CreateThread
#define SDL_CreateThread
Definition: SDL_dynapi_overrides.h:41
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_TLSGet
#define SDL_TLSGet
Definition: SDL_dynapi_overrides.h:481
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:236
NULL
#define NULL
Definition: begin_code.h:164
tls
static SDL_TLSID tls
Definition: testthread.c:21
quit
static void quit(int rc)
Definition: testthread.c:26
SDL_Thread
Definition: SDL_thread_c.h:54
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:54
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDL_WaitThread
#define SDL_WaitThread
Definition: SDL_dynapi_overrides.h:478

## quit()

static void quit | ( | int | rc | ) |

static

Definition at line 26 of file testthread.c.

References SDL_Quit, and SDLCALL.

Referenced by killed(), and main().

{
SDL_Quit();
exit(rc);
}
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:58

## ThreadFunc()

int ThreadFunc | ( | void * | data | ) |

Definition at line 33 of file testthread.c.

References alive, NULL, SDL_Delay, SDL_Log, SDL_ThreadID, SDL_TLSGet, SDL_TLSSet, and tls.

Referenced by main().

{
SDL_TLSSet(tls, "baby thread", NULL);
SDL_Log("Started thread %s: My thread id is %lu, thread data = %s\n",
(char *) data, SDL_ThreadID(), (const char *)SDL_TLSGet(tls));
while (alive) {
SDL_Log("Thread '%s' is alive!\n", (char *) data);
SDL_Delay(1 * 1000);
}
SDL_Log("Thread '%s' exiting!\n", (char *) data);
return (0);
}
SDL_TLSSet
#define SDL_TLSSet
Definition: SDL_dynapi_overrides.h:482
SDL_ThreadID
#define SDL_ThreadID
Definition: SDL_dynapi_overrides.h:475
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
alive
static int alive
Definition: testthread.c:22
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_TLSGet
#define SDL_TLSGet
Definition: SDL_dynapi_overrides.h:481
NULL
#define NULL
Definition: begin_code.h:164
tls
static SDL_TLSID tls
Definition: testthread.c:21

## Variable Documentation

## alive

int alive = 0

static

Definition at line 22 of file testthread.c.

Referenced by killed(), main(), and ThreadFunc().

## tls

SDL_TLSID tls

static

Definition at line 21 of file testthread.c.

Referenced by main(), and ThreadFunc().